/****************************************************************************/
/* FreeScale ColdFire V1̐FXeXg                                        */
/*                                    designed by hamayan                   */
/*                                    Copyright (c)  since 2008 */
/****************************************************************************/
#include <hidef.h> /* for EnableInterrupts macro */
#include <string.h> /**/
#include "derivative.h" /* include peripheral declarations */

#define  __MYTRON_H__
#include "mytron.h"

#define _CPU_CLOCK_  (50328840U)
#define _BUS_CLOCK_  (_CPU_CLOCK_ / 2)
#define PERIOD_1s    (_BUS_CLOCK_ / 128)
#define PERIOD_3R9ms  (_BUS_CLOCK_ / 128 / 256)
#define PERIOD_7R8ms  (_BUS_CLOCK_ / 128 / 128)
#define PERIOD_15R6ms  (_BUS_CLOCK_ / 128 / 64)
#define PERIOD_62R5ms  (_BUS_CLOCK_ / 128 / 16)
#define PERIOD_1ms  (_BUS_CLOCK_ / 128 / 1000)

/****************************************************************************/
/* vg^Cv錾                                                         */
/****************************************************************************/

/****************************************************************************/
/* ϐ̊F                                                         */
/****************************************************************************/
unsigned long hospac_cfv1_imsk = 0;	/*荞݃}XNl*/

/****************************************************************************/
/* IDLE^XN                                                               */
/* Ɏsׂ^XNÃ^XNĂ΂                       */
/****************************************************************************/
void idl_loop( void )
{
  for( ; ; )
  {
//    _Wait;
  }
}

/****************************************************************************/
/* wait                                                                     */
/****************************************************************************/
static void wait( RELTIM delay )
{
  SYSTIM next;

  next.utime = systime.utime;
  next.ltime = systime.ltime + delay;
  if( next.ltime < systime.ltime ) next.utime++;  /*オ肪鎞*/

  while( systime.utime < next.utime || (systime.utime == next.utime && systime.ltime < next.ltime) ) rot_rdq( TPRI_SELF );
//  while( systime.utime < next.utime || (systime.utime == next.utime && systime.ltime < next.ltime) ) tslp_tsk( (TMO)TMO_POL );
}

/****************************************************************************/
/* ^XNP                                                                 */
/* WX^D0ɋNp[^ĂB                                 */
/****************************************************************************/
void task1( VP_INT exinf )
{
  int tid = ref_tst();

  exinf *= tid;

  for( ; ; )
  {
    tslp_tsk( (RELTIM)exinf );
//    wait( (RELTIM)exinf );

    switch ( tid )
    {
      case 1 :
        PTAD_PTAD1 ^= 1;
        break;

      case 2 :
        PTAD_PTAD2 ^= 1;
        break;

      case 3 :
        PTAD_PTAD3 ^= 1;
        break;

      case 4 :
        PTBD_PTBD0 ^= 1;
        break;

      case 5 :
        PTBD_PTBD1 ^= 1;
        break;

      case 6 :
        PTBD_PTBD2 ^= 1;
        break;

      default :
        PTBD_PTBD3 ^= 1;
        break;
    }
  }
}

/****************************************************************************/
/* vOmain                                                           */
/****************************************************************************/
extern unsigned long far _SP_INIT, _SDA_BASE;

void main( void )
{
  int i;
  TASK_CONTEXT *c_text;
  unsigned long _A5;

  /*܂ϐ̃|C^ƂėpĂ܂A5WX^̓eۑĒu*/
  __asm {
    move.l  a5,_A5
  };

  /*@\^C}[gp*/
  TPM1SC = 0x07;     /*0b0 0 00 111 ^C}[~Asystem clock / 128*/
  TPM1MOD = PERIOD_1ms;  /*ݒ*/
  TPM1SC_CLKSx = 1;  /*oXNbN̑I*/
  TPM1SC_TOIE = 1;   /*interrupt enable*/

  /*LEDڑĂ|[g̃f[^fBNVWX^̑B܂vɏo͐ݒ*/
  PTADD = 0x0f;
  PTBDD = 0x0f;

  /*^XN̏*/
  for( i = 1; i <= MAX_TID_NUMBER; i++ )
  {
    /*2Ԗڂ̃^XNAɃX^bNɃReLXgۑĂlɌ*/
    c_text = (TASK_CONTEXT *)((char *)tcb[ i ].sp - sizeof(TASK_CONTEXT));
    c_text->pc = tcb[ i ].fn;       /*N֐̃AhX*/
    c_text->ccr = 0x40002000;       /*SRWX^̏l*/
    c_text->d[0] = (unsigned long)tcb[ i ].exinf;  /*Np[^*/
    c_text->a[5] = _A5;       /*?*/
    tcb[ i ].sp = c_text;           /*炪ۑꂽ̃X^bNAhX*/
  }

  __asm {
    move.l   sp,INT_SSP    //荞݃X^bN|C^ۑ̈ɃRs[
    movea.l  tcb[0].sp,sp  //^XNRg[ubN^XNX^bN擾
    movea.l  tcb[0].fn,a0  //^XNRg[ubNN֐̃AhX擾
    move.l   tcb[0].exinf,d0  //Np[^
    move.w   SR,d1         //
    andi.l   #0xF8FF,d1    //荞݋
    move.w   d1,SR     
    jmp  (a0)              //ŏ̃^XNփWv
  };
}

/****************************************************************************/
/* TPM1 `l1̃CvbgLv`/RyA}b`荞            */
/****************************************************************************/
#if 0
interrupt VectorNumber_Vtpm1ch0 void TPM1_C_MATCH_ISR( void )
{
  TPM1C1SC_CH1F = 0;	/*clear status*/
}

/****************************************************************************/
/* TPM1 I[o[t[荞                                              */
/****************************************************************************/
interrupt VectorNumber_Vtpm1ovf void TPM1_OVF_ISR( void )
{
  static int count;

  TPM1SC_TOF = 0;	/*clear status*/
  systime++;  /*VXe^C}[̍XV*/

  if( ++count >= 197 )
  {
    PTCD_PTCD0 ^= 1;
    count = 0;
  }
}
#endif

/****************************************************************************/
/*                                    designed by hamayan                   */
/*                                    Copyright (c)  since 2008 */
/****************************************************************************/
